﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Themes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GroupbyThemingTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
          
            CreateCustomMetroTheme(this.grid, new Style1());
        }

        private static void CreateCustomMetroTheme(XamDataGrid grid, ResourceDictionary myColors)
        {
            var accentColorKey = "Color_024";
            var metroDictionary = ThemeManager.GetResourceSet("Metro", ThemeManager.AllGroupingsLiteral);
            var accentColor = (Color)metroDictionary[accentColorKey];
            var newAccentColor = ((GroupbyThemingTest.Style1)myColors).Accent;


            if (newAccentColor != null)
            {
                ChangeColor(metroDictionary, accentColor, newAccentColor);
                metroDictionary[accentColorKey] = newAccentColor;

                foreach (var grouping in ThemeManager.GetGroupingsForType(grid.GetType()))
                {
                    ThemeManager.Register("CustomMetro", grouping, metroDictionary);
                }

            }

        }

        private static void ChangeColor(ResourceDictionary dictionary, Color oldColor, Color newColor)
        {
            foreach (var key in dictionary.Keys)
            {
                if (dictionary[key] is SolidColorBrush brush && brush.Color == oldColor)
                {
                    dictionary[key] = new SolidColorBrush(newColor);
                }
            }
            foreach (var mergedDictionary in dictionary.MergedDictionaries)
            {
                ChangeColor(mergedDictionary, oldColor, newColor);
            }
        }
    }

    public partial class Style1 : ResourceDictionary
    {
        // this color can be changed later
        public Color Accent { get; set; }

        public Style1()
        {
            Accent = Colors.Red;          
        }
    }
}
